/* aesthetic 'centripetal' - makes nodes move away from the centroid */
/* $Id: ae_centripetal.c,v 1.0 1992/10/23 06:37:10 coleman Exp $ */

#include <aesth.h>
#include <at_centroid.h>

declare_aesth(centripetal);

define_setup(centripetal) {
    return;
}

define_aesth(centripetal) {
    unsigned i;
    aglo_real *centroid;

    at_centroid(&centroid, graph, state);

    for (i=0;i<graph->vertices;i++) {
        aglo_point delta;
        aglo_real mag2;
        aglo_point force_delta;

        aglo_point_sub(delta, state[i], centroid);
        aglo_point_mag2(&mag2, delta);
        mag2 = fmax(mag2, 1e-8); /* avoid div by 0 */

        aglo_point_scalar_mult(force_delta, 1/mag2, delta);

        aglo_point_add(gradient[i], gradient[i], force_delta);
    }
}
