/* aesthetic 'minimize edge length' - makes edges shrink in length */
/* $Id: ae_min_edge_length.c,v 1.1 1992/10/23 06:28:21 coleman Exp $ */

#include <aesth.h>

declare_aesth(min_edge_length);

define_setup(min_edge_length) {
    return;
}

define_aesth(min_edge_length) {
    unsigned i, j;
    aglo_edge_record p;

    for (i=0;i<graph->vertices;i++)
        for (p=graph->edge_table[i];p;p=p->next)
            if (i < (j=p->tail)) {
                aglo_point delta;
                aglo_real mag;
                aglo_point force_delta;

                aglo_point_sub(delta, state[i], state[j]);
                aglo_point_mag(&mag, delta);
                mag = fmax(mag, 1e-8); /* avoid div by 0 */

                aglo_point_scalar_mult(force_delta, mag, delta);

                aglo_point_dec(gradient[i], force_delta);
                aglo_point_inc(gradient[j], force_delta);
            }
}
