/* aesthetic 'min level variance' - put nodes on same level on same X coord */
/* $Id: ae_min_level_variance.c,v 1.1 1993/05/26 23:20:16 coleman Exp $ */

#include <aesth.h>
#include <at_node_level.h>

declare_aesth(min_level_variance);

define_setup(min_level_variance) {
    at_setup_node_level(graph);
}

define_aesth(min_level_variance) {
    unsigned i, l;
    aglo_real level_distance_sum[AGLO_MAX_GRAPH_SIZE] = {0}; /* sigma X */
#if 0
    aglo_real level_distance_2_sum[AGLO_MAX_GRAPH_SIZE] = {0}; /* sigma (X^2) */
#endif

#define AXIS (0)

    for (l=0;at_level_nodes_size[l];l++) {
        for (i=0;i<at_level_nodes_size[l];i++)
            level_distance_sum[l] += state[at_level_nodes[l][i]][AXIS];
        level_distance_sum[l] /= i;
    }

    for (l=0;at_level_nodes_size[l];l++)
        for (i=0;i<at_level_nodes_size[l];i++) {
            aglo_real delta = level_distance_sum[l] - state[at_level_nodes[l][i]][AXIS];
            aglo_real mag = fabs(delta);
            if (mag > 0.0L) {                   /* check this */
                aglo_real force_delta = mag * mag * delta;
                gradient[at_level_nodes[l][i]][AXIS] += force_delta;
            }
        }
}
