/* aesthetic 'node repulsion' - makes nodes spread apart */
/* $Id: ae_node_repulsion.c,v 1.3 1992/10/24 03:50:18 coleman Exp $ */

#include <aesth.h>

declare_aesth(node_repulsion);

define_setup(node_repulsion) {
    return;
}

define_aesth(node_repulsion) {
    unsigned i, j;

    for (i=1;i<graph->vertices;i++)
        for (j=0;j<i;j++) {
            aglo_point delta;
            aglo_real mag2;
            aglo_point force_delta;

            aglo_point_sub(delta, state[i], state[j]);
            aglo_point_mag2(&mag2, delta);
            mag2 = fmax(mag2, 1e-8); /* avoid div by 0 */

            aglo_point_scalar_mult(force_delta, 1/mag2, delta);

            aglo_point_add(gradient[i], gradient[i], force_delta);
            aglo_point_sub(gradient[j], gradient[j], force_delta);
        }
}
