/* attribute 'centroid' - centroid of current state */
/* $Id: at_centroid.c,v 1.0 1992/10/23 06:39:21 coleman Exp $ */

#include <at_centroid.h>
#include <attribute.h>
#include <point.h>

void at_centroid(aglo_real **centroid, aglo_graph graph,
                 aglo_state_vector state) {
    static aglo_point cached_centroid;
    static unsigned long at_state_sequence;

    *centroid = cached_centroid;

    if (UPDATE_STATE_ATTRIBUTE) {
        unsigned i;

        aglo_point_zero(cached_centroid);
        for (i=0;i<graph->vertices;i++)
            aglo_point_add(cached_centroid, cached_centroid, state[i]);
        aglo_point_scalar_mult(cached_centroid, 1.0L / graph->vertices,
                               cached_centroid);
    }
}
